/**
 * core.js - all global scripts belong in this file.
 */

// NAMESPACE FOR COMMON FUNCTIONS/OBJECTS
var COMMONUTILS = {
    //
    pageWidth : function () {"use strict";
        return document.documentElement.clientWidth;
    },

    // OBJ TO HOLD USERS CURRENT WEBPAGE LOCATION
    currentPage : window.location.pathname.substring (window.location.pathname.lastIndexOf ('/') + 1),

    // FUNCTION TO EXECUTE CODE BASED ON LOCATION
    userLocation : function (pagename) {"use strict";
        var page = pagename;
        $ ('#nav a').removeClass ('active');
        switch(page) {
            case 'index':
                $ ('#nav-home').addClass ('active');
                break;
            case 'about':
                $ ('#nav-about').addClass ('active');
                break;
            case 'cast':
                $ ('#nav-cast').addClass ('active');
                break;
            case 'news':
                $ ('#nav-news').addClass ('active');
                break;
            case 'reviews':
                $ ('#nav-reviews').addClass ('active');
                break;
            case 'tickets':
                $ ('#nav-tickets').addClass ('active');
                break;
            case 'gallery':
                $ ('#nav-gallery').addClass ('active');
                break;
            case 'privacy':
                $ ('#nav a').removeClass ('active');
                break;
            default:
                // No Case
                $ ('#nav-home').addClass ('active');
        }
    },

    optinFormValidate: function() {
    	"use strict";

      var formName = "";

      $(".subscribe").each(function(i){

      	//console.log(i);
      	formName = "optin"+i;
      	$(this).attr("id",formName);

          //
          $(this).validate({
            rules : {
              email : { required : true, email : true }/*,
              zip : 'required'*/
            },
            messages : {
              email : 'Enter a valid email'/*,
              zip : 'Enter your zip code'*/
            },
            errorPlacement : function(error, element) {
              element.attr('placeholder', error[0].outerText);
            },
            submitHandler : function(form) {
              $.ajax({
                url : './_inc/optin_action.php',
                type : 'POST',
                data : $(form).serialize() + '&ajax=true',
                success : function() {
                  $(form).hide();
                  $(form).parent("div").append('<h3 class="form-thanks">THANK YOU FOR SIGNING UP.<br /><span>Check your email to confirm your subscription</span></h3>');
                }
              });
              return false;
            }
          });

      });
    },

    nav: function() {
    	"use strict";

    	$("#btn-menu").on("click",function(e){
      	e.preventDefault();
      	if( $("#nav").hasClass("open") ){
        	$("#nav, #btn-menu").removeClass("open");
        	$("#btn-menu").removeClass("fa-times-thin").addClass("fa-bars");
      	} else {
        	$("#nav, #btn-menu").addClass("open");
        	$("#btn-menu").addClass("fa-times-thin").removeClass("fa-bars");
      	}
    	});

    	$("#icon-envelope").click(function(){
      	$("html").addClass("modal-open");
    	});

    },

    video: function() {
    	"use strict";

    	$(".video-link").each(function(e){
      	  if( $(this).data("thumb") != "" ){
        	  $(this).html('<div class="video-thumb"><img src="'+ $(this).data("thumb") +'" class="w100"></div>');
      	  } else {
        	  $(this).html('<div class="video-thumb"><img src="http://img.youtube.com/vi/'+ $(this).data("id") +'/hqdefault.jpg" class="w100"></div>');
      	  }
      	  if( $(this).data("caption") != "" ){
      	    //console.log('yo');
        	  $(this).append("<div class='video-caption'>"+$(this).data("caption")+"</div>");
      	  }
    	});

    	$(document).on("click",".video-link",function(e){
    	    e.preventDefault();
    	    if( $("#video-overlay-close").length == 0 ){
      	    $("#video-overlay").append('<a id="video-overlay-close"></a>');
    	    }
        	$("#video-overlay-inner").html('<iframe src="https://www.youtube.com/embed/'+ $(this).data("id") +'?rel=0&modestbranding=1&autohide=1&showinfo=0&autoplay=1" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>');
        	$("html").addClass("video-overlay-open");
    	});

    	$(document).on("click","#video-overlay-close, #video-overlay",function(e){
    	    e.preventDefault();
        	$("#video-overlay-inner").html('');
        	$("html").removeClass("video-overlay-open");
    	});

    },

    quotes: function() {
    	"use strict";
      $('#quotes').quote_rotator();

    }
};

//Namespace for bio functions
var bioGrid = {};

bioGrid.bioindex = 0;
bioGrid.bios = [];

bioGrid.loadBios = function (divID, page) {"use strict";
    //Cast & Creative Bios
    $(divID).load(page, null, function () {
        //
        if (divID === "#cast-bios") {
            var thumbs = "";
            for (var i=1; i <= $("#cast-bios .team-member").length; i++) {

                thumbs += '<a class="cast-member actor-' + i + '" href="#' + (i - 1) + '" ><div class="cast-image">' + $('#cast-bios .team-member:nth-child(' + i + ') .castpic').html() + '</div><div class="cast-name">' + $('#cast-bios .team-member:nth-child(' + i + ') h3 strong').html() + '</div><div class="cast-role">' + $('#cast-bios .team-member:nth-child(' + i + ') h3 em').html() + '</div></a>';
                bioGrid.bios.push($('#cast-bios .team-member:nth-child('+i+')').html());

            }
        } else if (divID === "#creative-bios") {
            var thumbs = "";
            for (var j=1; j <= $("#creative-bios .team-member").length; j++) {
            thumbs += '<a class="cast-member actor-' + bioGrid.bios.length + '" href="#' + bioGrid.bios.length + '" ><div class="cast-name">' + $('#creative-bios .team-member:nth-child(' + j + ') h3 strong').html() + '</div><div class="cast-role">' + $('#creative-bios .team-member:nth-child(' + j + ') h3 em').html() + '</div></a>';
            bioGrid.bios.push($('#creative-bios .team-member:nth-child('+ j +')').html());

          }

        }

        $(divID).html(thumbs);

        $(divID + " .cast-member").click( function(e) {
            e.preventDefault();
            bioGrid.bioindex = Number($(this).attr("href").split("#")[1]);

            //add overlay
            $("#overlay-inner").html("").html("<div>" + bioGrid.bios [ ($(this).attr("href").split("#") [1]) ] + "</div>");
            $("html, body").addClass ("overlay-open");
            $(".overlay").addClass ("open");


            //next/prev
            $(".overlay-prev, .overlay-next").show();
            if (bioGrid.bioindex == (bioGrid.bios.length - 1)) {
                $(".overlay-next").hide();
            } else if (bioGrid.bioindex == 0) {
                $(".overlay-prev").hide();
            }

            //scroll, if necessary
            if ( $('.overlay .container').height() > $(window).height() ) {
                var slideheight = $(window).height () - $(".overlay-close").height()*2 - 100;
                $('#overlay-inner > div').slimscroll ({
                    height : slideheight + 'px', alwaysVisible : true, color : '#2dc2cd', railVisible : true, railColor : '#000'
                });
            }
        });
    })
};

//Next/Previous navigation
bioGrid.bioNav = function () {
    $(".overlay-next").click(function(e) {
        e.preventDefault();
        $(".overlay-prev").show();
        if (bioGrid.bioindex == (bioGrid.bios.length - 2)) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex + 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });

    $(".overlay-prev").click(function(e) {
        e.preventDefault();
        $(".overlay-next").show();
        if (bioGrid.bioindex == 1) {
            $(this).hide();
        }
        else { $(this).show(); }
        bioGrid.bioindex = bioGrid.bioindex - 1;
        $("#overlay-inner").fadeOut(300, function() {
            $(this).html(bioGrid.bios[bioGrid.bioindex]).fadeIn(500);
        });
    });
};

// Close Cast Overlay
bioGrid.hideOverlay = function () {
    $ (".overlay-close").click (function (e) {
        e.preventDefault ();
        $ ("html, body").removeClass ("overlay-open");
        $ (".overlay").removeClass ("open");
    });
};

// jQuery Namespace
$ (document).ready (function () {"use strict";
    $('html').addClass('page-loaded');
    COMMONUTILS.optinFormValidate();
    bioGrid.loadBios('#cast-bios','cast.html');
    bioGrid.loadBios('#creative-bios','creative.html');
    bioGrid.bioNav();
    bioGrid.hideOverlay();
});

// EOF
